## gudhi 3.1.1+dfsg

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(GUDHI)

include(CMakeGUDHIVersion.txt)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

set(GUDHI_MODULES "" CACHE INTERNAL "GUDHI_MODULES")
set(GUDHI_MISSING_MODULES "" CACHE INTERNAL "GUDHI_MISSING_MODULES")

# This variable is used by Cython CMakeLists.txt and by GUDHI_third_party_libraries to know its path
set(GUDHI_PYTHON_PATH "python")

# For third parties libraries management - To be done last as CGAL updates CMAKE_MODULE_PATH
include(GUDHI_third_party_libraries NO_POLICY_SCOPE)

include(GUDHI_compilation_flags)

# Add your new module in the list, order is not important
include(GUDHI_modules)

add_gudhi_module(common)
add_gudhi_module(Alpha_complex)
add_gudhi_module(Bitmap_cubical_complex)
add_gudhi_module(Bottleneck_distance)
add_gudhi_module(Cech_complex)
add_gudhi_module(Contraction)
add_gudhi_module(Hasse_complex)
add_gudhi_module(Persistence_representations)
add_gudhi_module(Persistent_cohomology)
add_gudhi_module(Rips_complex)
add_gudhi_module(Simplex_tree)
add_gudhi_module(Skeleton_blocker)
add_gudhi_module(Spatial_searching)
add_gudhi_module(Subsampling)
add_gudhi_module(Tangential_complex)
add_gudhi_module(Toplex_map)
add_gudhi_module(Witness_complex)
add_gudhi_module(Nerve_GIC)

# For "make doxygen" - Requires GUDHI_USER_VERSION_DIR to be set
set(GUDHI_USER_VERSION_DIR ${CMAKE_SOURCE_DIR})
include(GUDHI_doxygen_target)

#---------------------------------------------------------------------------------------
# Gudhi compilation part
include_directories(include)

# Include module CMake subdirectories
# GUDHI_SUB_DIRECTORIES is managed in CMAKE_MODULE_PATH/GUDHI_modules.cmake
foreach(GUDHI_MODULE ${GUDHI_MODULES})
  foreach(GUDHI_SUB_DIRECTORY ${GUDHI_SUB_DIRECTORIES})
    if(EXISTS ${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/CMakeLists.txt)
      add_subdirectory(${CMAKE_SOURCE_DIR}/${GUDHI_SUB_DIRECTORY}/${GUDHI_MODULE}/)
    endif()
  endforeach()
endforeach()

add_subdirectory(GudhUI)

if (WITH_GUDHI_PYTHON)
  # specific for cython module
  add_subdirectory(${GUDHI_PYTHON_PATH})
else()
  message("++ Python module will not be compiled because WITH_GUDHI_PYTHON is set to OFF")
  set(GUDHI_MISSING_MODULES ${GUDHI_MISSING_MODULES} "python")
endif()

message("++ GUDHI_MODULES list is:\"${GUDHI_MODULES}\"")
message("++ GUDHI_MISSING_MODULES list is:\"${GUDHI_MISSING_MODULES}\"")

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# GUDHIConfig.cmake
# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE GUDHI)

message("++ make install will install ${PROJECT_NAME} in the following directory : ${CMAKE_INSTALL_PREFIX}")
# Create the GUDHIConfig.cmake and GUDHIConfigVersion files
set(CONF_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/include;${CMAKE_INSTALL_PREFIX}/include")
configure_file(GUDHIConfig.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake" @ONLY)
configure_file(GUDHIConfigVersion.cmake.in "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake" @ONLY)

#---------------------------------------------------------------------------------------

#---------------------------------------------------------------------------------------
# Gudhi installation part

# Install the GUDHIConfig.cmake and GUDHIConfigVersion.cmake
install(FILES
  "${PROJECT_BINARY_DIR}/GUDHIConfig.cmake"
  "${PROJECT_BINARY_DIR}/GUDHIConfigVersion.cmake"
  DESTINATION share/gudhi)

# install the include file on "make install"
install(DIRECTORY include/gudhi DESTINATION include)
#---------------------------------------------------------------------------------------

=== src/python/CMakeLists.txt ===
project(Cython)

function( add_GUDHI_PYTHON_lib THE_LIB )
  if(EXISTS ${THE_LIB})
    get_filename_component(THE_LIB_FILE_NAME ${THE_LIB} NAME_WE)
    if(WIN32)
      message("++ ${THE_LIB} => THE_LIB_FILE_NAME = ${THE_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${THE_LIB_FILE_NAME}', " PARENT_SCOPE)
    else(WIN32)
      STRING(REGEX REPLACE "lib" "" UNIX_LIB_FILE_NAME ${THE_LIB_FILE_NAME})
      message("++ ${THE_LIB} => UNIX_LIB_FILE_NAME = ${UNIX_LIB_FILE_NAME}")
      set(GUDHI_PYTHON_LIBRARIES "${GUDHI_PYTHON_LIBRARIES}'${UNIX_LIB_FILE_NAME}', " PARENT_SCOPE)
    endif(WIN32)
  endif(EXISTS ${THE_LIB})
endfunction( add_GUDHI_PYTHON_lib )

# THE_TEST is the python test file name (without .py extension) containing tests functions
function( add_gudhi_py_test THE_TEST )
  if(PYTEST_FOUND)
    # use ${PYTHON_EXECUTABLE} -B, otherwise a __pycache__ directory is created in sources by python
    # use py.test no cache provider, otherwise a .cache file is created in sources by py.test
    add_test(NAME ${THE_TEST}_py_test
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
             COMMAND ${PYTHON_EXECUTABLE} -B -m pytest -p no:cacheprovider ${CMAKE_CURRENT_SOURCE_DIR}/test/${THE_TEST}.py)
  endif()
endfunction( add_gudhi_py_test )

# Set gudhi.__debug_info__
# WARNING : to be done before setup.py.in configure_file
function( add_gudhi_debug_info DEBUG_INFO )
  set(GUDHI_PYTHON_DEBUG_INFO "${GUDHI_PYTHON_DEBUG_INFO}    \"${DEBUG_INFO}\\n\" \\\n" PARENT_SCOPE)
endfunction( add_gudhi_debug_info )

if(PYTHONINTERP_FOUND)
  if(CYTHON_FOUND)
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'off_reader', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'simplex_tree', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'rips_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'periodic_cubical_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'persistence_graphical_tools', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'reader_utils', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'strong_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'bottleneck', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'nerve_gic', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'subsampling', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'tangential_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'alpha_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_witness_complex', ")
    set(GUDHI_PYTHON_MODULES "${GUDHI_PYTHON_MODULES}'euclidean_strong_witness_complex', ")
    # Modules that should not be auto-imported in __init__.py
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'representations', ")
    set(GUDHI_PYTHON_MODULES_EXTRA "${GUDHI_PYTHON_MODULES_EXTRA}'wasserstein', ")

    add_gudhi_debug_info("Python version ${PYTHON_VERSION_STRING}")
    add_gudhi_debug_info("Cython version ${CYTHON_VERSION}")
    if(PYTEST_FOUND)
      add_gudhi_debug_info("Pytest version ${PYTEST_VERSION}")
    endif()
    if(MATPLOTLIB_FOUND)
      add_gudhi_debug_info("Matplotlib version ${MATPLOTLIB_VERSION}")
    endif()
    if(NUMPY_FOUND)
      add_gudhi_debug_info("Numpy version ${NUMPY_VERSION}")
    endif()
    if(SCIPY_FOUND)
      add_gudhi_debug_info("Scipy version ${SCIPY_VERSION}")
    endif()
    if(SKLEARN_FOUND)
      add_gudhi_debug_info("Scikit-learn version ${SKLEARN_VERSION}")
    endif()
    if(OT_FOUND)
      add_gudhi_debug_info("POT version ${OT_VERSION}")
    endif()

    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_RESULT_OF_USE_DECLTYPE', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_ALL_NO_LIB', ")
    set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DBOOST_SYSTEM_NO_DEPRECATED', ")

    # Gudhi and CGAL compilation option
    if(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'/fp:strict', ")
    else(MSVC)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-std=c++14', ")
    endif(MSVC)
    if(CMAKE_COMPILER_IS_GNUCXX)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-frounding-math', ")
    endif(CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_CXX_COMPILER_ID MATCHES Intel)
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-fp-model strict', ")
    endif(CMAKE_CXX_COMPILER_ID MATCHES Intel)
    if (DEBUG_TRACES)
      # For programs to be more verbose
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DDEBUG_TRACES', ")
    endif()

    if (EIGEN3_FOUND)
      add_gudhi_debug_info("Eigen3 version ${EIGEN3_VERSION}")
      # No problem, even if no CGAL found
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_EIGEN3_ENABLED', ")
    endif (EIGEN3_FOUND)

    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'off_reader', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'simplex_tree', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'rips_complex', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'cubical_complex', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'periodic_cubical_complex', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'reader_utils', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'witness_complex', ")
    set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'strong_witness_complex', ")
    if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'bottleneck', ")
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'nerve_gic', ")
    endif ()
    if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'alpha_complex', ")
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'subsampling', ")
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'tangential_complex', ")
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'euclidean_witness_complex', ")
      set(GUDHI_PYTHON_MODULES_TO_COMPILE "${GUDHI_PYTHON_MODULES_TO_COMPILE}'euclidean_strong_witness_complex', ")
    endif ()

    if(CGAL_FOUND)
      can_cgal_use_cxx11_thread_local()
      if (NOT CGAL_CAN_USE_CXX11_THREAD_LOCAL_RESULT)
        if(CMAKE_BUILD_TYPE MATCHES Debug)
          add_GUDHI_PYTHON_lib("${Boost_THREAD_LIBRARY_DEBUG}")
        else()
          add_GUDHI_PYTHON_lib("${Boost_THREAD_LIBRARY_RELEASE}")
        endif()
        message("** Add Boost ${Boost_LIBRARY_DIRS}")
        set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${Boost_LIBRARY_DIRS}', ")
      endif()
      # Add CGAL compilation args
      if(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL header only version ${CGAL_VERSION}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_HEADER_ONLY', ")
      else(CGAL_HEADER_ONLY)
        add_gudhi_debug_info("CGAL version ${CGAL_VERSION}")
        add_GUDHI_PYTHON_lib("${CGAL_LIBRARY}")
        set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${CGAL_LIBRARIES_DIR}', ")
        message("** Add CGAL ${CGAL_LIBRARIES_DIR}")
        # If CGAL is not header only, CGAL library may link with boost system,
        if(CMAKE_BUILD_TYPE MATCHES Debug)
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_DEBUG}")
        else()
          add_GUDHI_PYTHON_lib("${Boost_SYSTEM_LIBRARY_RELEASE}")
        endif()
        set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${Boost_LIBRARY_DIRS}', ")
        message("** Add Boost ${Boost_LIBRARY_DIRS}")
      endif(CGAL_HEADER_ONLY)
      # GMP and GMPXX are not required, but if present, CGAL will link with them.
      if(GMP_FOUND)
        add_gudhi_debug_info("GMP_LIBRARIES = ${GMP_LIBRARIES}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_GMP', ")
        add_GUDHI_PYTHON_lib("${GMP_LIBRARIES}")
        set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${GMP_LIBRARIES_DIR}', ")
        message("** Add gmp ${GMP_LIBRARIES_DIR}")
        if(GMPXX_FOUND)
          add_gudhi_debug_info("GMPXX_LIBRARIES = ${GMPXX_LIBRARIES}")
          set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_GMPXX', ")
          add_GUDHI_PYTHON_lib("${GMPXX_LIBRARIES}")
          set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${GMPXX_LIBRARIES_DIR}', ")
          message("** Add gmpxx ${GMPXX_LIBRARIES_DIR}")
        endif(GMPXX_FOUND)
      endif(GMP_FOUND)
      if(MPFR_FOUND)
        add_gudhi_debug_info("MPFR_LIBRARIES = ${MPFR_LIBRARIES}")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DCGAL_USE_MPFR', ")
        add_GUDHI_PYTHON_lib("${MPFR_LIBRARIES}")
        # In case CGAL is not header only, all MPFR variables are set except MPFR_LIBRARIES_DIR - Just set it
        if(NOT MPFR_LIBRARIES_DIR)
          get_filename_component(MPFR_LIBRARIES_DIR ${MPFR_LIBRARIES} PATH)
        endif(NOT MPFR_LIBRARIES_DIR)
        set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${MPFR_LIBRARIES_DIR}', ")
        message("** Add mpfr ${MPFR_LIBRARIES}")
      endif(MPFR_FOUND)
endif(CGAL_FOUND)

    # Specific for Mac
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-mmacosx-version-min=10.12', ")
        set(GUDHI_PYTHON_EXTRA_LINK_ARGS "${GUDHI_PYTHON_EXTRA_LINK_ARGS}'-mmacosx-version-min=10.12', ")
    endif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

    # Loop on INCLUDE_DIRECTORIES PROPERTY
    get_property(GUDHI_INCLUDE_DIRECTORIES DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
    foreach(GUDHI_INCLUDE_DIRECTORY ${GUDHI_INCLUDE_DIRECTORIES})
      set(GUDHI_PYTHON_INCLUDE_DIRS "${GUDHI_PYTHON_INCLUDE_DIRS}'${GUDHI_INCLUDE_DIRECTORY}', ")
    endforeach()
    set(GUDHI_PYTHON_INCLUDE_DIRS "${GUDHI_PYTHON_INCLUDE_DIRS}'${CMAKE_SOURCE_DIR}/${GUDHI_PYTHON_PATH}/include', ")

    if (TBB_FOUND AND WITH_GUDHI_USE_TBB)
      add_gudhi_debug_info("TBB version ${TBB_INTERFACE_VERSION} found and used")
      set(GUDHI_PYTHON_EXTRA_COMPILE_ARGS "${GUDHI_PYTHON_EXTRA_COMPILE_ARGS}'-DGUDHI_USE_TBB', ")
      if(CMAKE_BUILD_TYPE MATCHES Debug)
        add_GUDHI_PYTHON_lib("${TBB_DEBUG_LIBRARY}")
        add_GUDHI_PYTHON_lib("${TBB_MALLOC_DEBUG_LIBRARY}")
      else()
        add_GUDHI_PYTHON_lib("${TBB_RELEASE_LIBRARY}")
        add_GUDHI_PYTHON_lib("${TBB_MALLOC_RELEASE_LIBRARY}")
      endif()
      set(GUDHI_PYTHON_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}'${TBB_LIBRARY_DIRS}', ")
      message("** Add tbb ${TBB_LIBRARY_DIRS}")
      set(GUDHI_PYTHON_INCLUDE_DIRS "${GUDHI_PYTHON_INCLUDE_DIRS}'${TBB_INCLUDE_DIRS}', ")
    endif()

    if(UNIX AND WITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS)
      set( GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS "${GUDHI_PYTHON_LIBRARY_DIRS}")
    endif(UNIX AND WITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS)

    # Generate setup.py file to cythonize Gudhi - This file must be named setup.py by convention
    configure_file(setup.py.in "${CMAKE_CURRENT_BINARY_DIR}/setup.py" @ONLY)

    # Generate gudhi/__init__.py
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/gudhi")
    configure_file("gudhi/__init__.py.in" "${CMAKE_CURRENT_BINARY_DIR}/gudhi/__init__.py" @ONLY)

    # Other .py files

=== src/Alpha_complex/benchmark/CMakeLists.txt ===
project(Alpha_complex_benchmark)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  add_executable(Alpha_complex_3d_benchmark Alpha_complex_3d_benchmark.cpp)
  target_link_libraries(Alpha_complex_3d_benchmark ${CGAL_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(Alpha_complex_3d_benchmark ${TBB_LIBRARIES})
  endif()
endif ()

=== src/Alpha_complex/utilities/CMakeLists.txt ===
project(Alpha_complex_utilities)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  add_executable (alpha_complex_persistence alpha_complex_persistence.cpp)
  target_link_libraries(alpha_complex_persistence ${CGAL_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY})

  if (TBB_FOUND)
    target_link_libraries(alpha_complex_persistence ${TBB_LIBRARIES})
  endif(TBB_FOUND)
  add_test(NAME Alpha_complex_utilities_safe_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
      "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "safe.pers")
  add_test(NAME Alpha_complex_utilities_fast_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
      "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "fast.pers" "-f")
  add_test(NAME Alpha_complex_utilities_exact_alpha_complex_persistence COMMAND $<TARGET_FILE:alpha_complex_persistence>
      "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-p" "2" "-m" "0.45" "-o" "exact.pers" "-e")
  if (DIFF_PATH)
    add_test(Alpha_complex_utilities_diff_exact_alpha_complex ${DIFF_PATH}
             "exact.pers" "safe.pers")
    add_test(Alpha_complex_utilities_diff_fast_alpha_complex ${DIFF_PATH}
             "fast.pers" "safe.pers")
  endif()
  
  install(TARGETS alpha_complex_persistence DESTINATION bin)

  add_executable(alpha_complex_3d_persistence alpha_complex_3d_persistence.cpp)
  target_link_libraries(alpha_complex_3d_persistence ${CGAL_LIBRARY} ${Boost_PROGRAM_OPTIONS_LIBRARY})
  if (TBB_FOUND)
    target_link_libraries(alpha_complex_3d_persistence ${TBB_LIBRARIES})
  endif(TBB_FOUND)

  add_test(NAME Alpha_complex_utilities_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
          "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
          "-p" "2" "-m" "0.45" "-o" "safe_3d.pers")

  add_test(NAME Alpha_complex_utilities_exact_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
          "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
          "-p" "2" "-m" "0.45" "-o" "exact_3d.pers" "-e")

  add_test(NAME Alpha_complex_utilities_safe_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
          "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off"
          "-p" "2" "-m" "0.45" "-o" "fast_3d.pers" "-f")

  if (DIFF_PATH)
    add_test(Alpha_complex_utilities_diff_exact_alpha_complex_3d ${DIFF_PATH}
            "exact_3d.pers" "safe_3d.pers")
    add_test(Alpha_complex_utilities_diff_fast_alpha_complex_3d ${DIFF_PATH}
            "fast_3d.pers" "safe_3d.pers")
  endif()

  add_test(NAME Alpha_complex_utilities_periodic_alpha_complex_3d_persistence COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
          "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
          "-c" "${CMAKE_SOURCE_DIR}/data/points/iso_cuboid_3_in_0_1.txt"
          "-p" "2" "-m" "0")

  add_test(NAME Alpha_complex_utilities_weighted_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
          "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
          "-w" "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.weights"
          "-p" "2" "-m" "0")

  add_test(NAME Alpha_complex_utilities_weighted_periodic_alpha_complex_3d COMMAND $<TARGET_FILE:alpha_complex_3d_persistence>
      "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.off"
      "-w" "${CMAKE_SOURCE_DIR}/data/points/grid_10_10_10_in_0_1.weights"
      "-c" "${CMAKE_SOURCE_DIR}/data/points/iso_cuboid_3_in_0_1.txt"
      "-p" "2" "-m" "0" "-e")

  install(TARGETS alpha_complex_3d_persistence DESTINATION bin)

endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

=== src/Bottleneck_distance/example/CMakeLists.txt ===
project(Bottleneck_distance_examples)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  add_executable (bottleneck_basic_example bottleneck_basic_example.cpp)

  if (TBB_FOUND)
    target_link_libraries(bottleneck_basic_example ${TBB_LIBRARIES})
  endif(TBB_FOUND)
  
  add_test(NAME Bottleneck_distance_example_basic COMMAND $<TARGET_FILE:bottleneck_basic_example>)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

if (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)
  add_executable (alpha_rips_persistence_bottleneck_distance alpha_rips_persistence_bottleneck_distance.cpp)
  target_link_libraries(alpha_rips_persistence_bottleneck_distance ${Boost_PROGRAM_OPTIONS_LIBRARY})

  if (TBB_FOUND)
    target_link_libraries(alpha_rips_persistence_bottleneck_distance ${TBB_LIBRARIES})
  endif(TBB_FOUND)
  
  add_test(NAME Bottleneck_distance_example_alpha_rips_persistence_bottleneck
      COMMAND $<TARGET_FILE:alpha_rips_persistence_bottleneck_distance>
      "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" "-r" "0.15" "-m" "0.12" "-d" "3" "-p" "3")
endif (NOT CGAL_WITH_EIGEN3_VERSION VERSION_LESS 4.11.0)

=== src/Cech_complex/benchmark/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(Cech_complex_benchmark)

# Do not forget to copy test files in current binary dir
file(COPY "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

add_executable(cech_complex_benchmark cech_complex_benchmark.cpp)
target_link_libraries(cech_complex_benchmark ${Boost_SYSTEM_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})

if (TBB_FOUND)
  target_link_libraries(cech_complex_benchmark ${TBB_LIBRARIES})
endif()

=== src/Cech_complex/test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(Cech_complex_tests)

include(GUDHI_boost_test)

add_executable ( Cech_complex_test_unit test_cech_complex.cpp )
if (TBB_FOUND)
  target_link_libraries(Cech_complex_test_unit ${TBB_LIBRARIES})
endif()

# Do not forget to copy test files in current binary dir
file(COPY "${CMAKE_SOURCE_DIR}/data/points/alphacomplexdoc.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

gudhi_add_boost_test(Cech_complex_test_unit)

=== src/Cech_complex/utilities/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(Cech_complex_utilities)

add_executable(cech_persistence cech_persistence.cpp)
target_link_libraries(cech_persistence ${Boost_PROGRAM_OPTIONS_LIBRARY})

if (TBB_FOUND)
  target_link_libraries(cech_persistence ${TBB_LIBRARIES})
endif()

add_test(NAME Cech_complex_utility_from_rips_on_tore_3D COMMAND $<TARGET_FILE:cech_persistence>
    "${CMAKE_SOURCE_DIR}/data/points/tore3D_300.off" "-r" "0.25" "-m" "0.5" "-d" "3" "-p" "3")

install(TARGETS cech_persistence DESTINATION bin)

=== src/Contraction/example/CMakeLists.txt ===
project(Contraction_examples)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  add_executable(RipsContraction Rips_contraction.cpp)

  add_executable(GarlandHeckbert Garland_heckbert.cpp)
  target_link_libraries(GarlandHeckbert ${Boost_TIMER_LIBRARY})

  add_test(NAME Contraction_example_tore3D_0.2 COMMAND $<TARGET_FILE:RipsContraction>
    "${CMAKE_SOURCE_DIR}/data/points/tore3D_1307.off" "0.2")
  # TODO(DS) : These tests are too long under Windows
  #add_test(NAME Contraction_example_sphere_0.2 COMMAND $<TARGET_FILE:RipsContraction>
  #    "${CMAKE_SOURCE_DIR}/data/points/sphere3D_2646.off" "0.2")
  #add_test(NAME Contraction_example_SO3_0.3 COMMAND $<TARGET_FILE:RipsContraction>
  #    "${CMAKE_SOURCE_DIR}/data/points/SO3_10000.off" "0.3")

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== src/Nerve_GIC/test/CMakeLists.txt ===
project(Graph_induced_complex_tests)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)
  include(GUDHI_boost_test)

  add_executable ( Nerve_GIC_test_unit test_GIC.cpp )
  if (TBB_FOUND)
    target_link_libraries(Nerve_GIC_test_unit ${TBB_LIBRARIES})
  endif()

  file(COPY data DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  gudhi_add_boost_test(Nerve_GIC_test_unit)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== src/Nerve_GIC/utilities/CMakeLists.txt ===
project(Nerve_GIC_examples)

if (NOT CGAL_VERSION VERSION_LESS 4.11.0)

  add_executable ( Nerve Nerve.cpp )
  add_executable ( VoronoiGIC VoronoiGIC.cpp )

  if (TBB_FOUND)
    target_link_libraries(Nerve ${TBB_LIBRARIES})
    target_link_libraries(VoronoiGIC ${TBB_LIBRARIES})
  endif()

  file(COPY KeplerMapperVisuFromTxtFile.py km.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
  # Copy files for not to pollute sources when testing
  file(COPY "${CMAKE_SOURCE_DIR}/data/points/human.off" DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)

  add_test(NAME Nerve_GIC_utilities_nerve COMMAND $<TARGET_FILE:Nerve>
      "human.off" "2" "10" "0.3")

  add_test(NAME Nerve_GIC_utilities_VoronoiGIC COMMAND $<TARGET_FILE:VoronoiGIC>
      "human.off" "100")

  install(TARGETS Nerve DESTINATION bin)
  install(TARGETS VoronoiGIC DESTINATION bin)
  install(FILES KeplerMapperVisuFromTxtFile.py km.py km.py.COPYRIGHT DESTINATION bin)

endif (NOT CGAL_VERSION VERSION_LESS 4.11.0)

=== src/Persistence_representations/example/CMakeLists.txt ===
project(Persistence_representations_example)

add_executable ( Persistence_representations_example_landscape_on_grid persistence_landscape_on_grid.cpp )
add_test(NAME Persistence_representations_example_landscape_on_grid
    COMMAND $<TARGET_FILE:Persistence_representations_example_landscape_on_grid>)
install(TARGETS Persistence_representations_example_landscape_on_grid DESTINATION bin)

add_executable ( Persistence_representations_example_landscape persistence_landscape.cpp )
add_test(NAME Persistence_representations_example_landscape
    COMMAND $<TARGET_FILE:Persistence_representations_example_landscape>)
install(TARGETS Persistence_representations_example_landscape DESTINATION bin)

add_executable ( Persistence_representations_example_intervals persistence_intervals.cpp )
add_test(NAME Persistence_representations_example_intervals
    COMMAND $<TARGET_FILE:Persistence_representations_example_intervals>
    "${CMAKE_SOURCE_DIR}/data/persistence_diagram/first.pers")
install(TARGETS Persistence_representations_example_intervals DESTINATION bin)

add_executable ( Persistence_representations_example_vectors persistence_vectors.cpp )
add_test(NAME Persistence_representations_example_vectors
    COMMAND $<TARGET_FILE:Persistence_representations_example_vectors>)
install(TARGETS Persistence_representations_example_vectors DESTINATION bin)

add_executable ( Persistence_representations_example_heat_maps persistence_heat_maps.cpp )
add_test(NAME Persistence_representations_example_heat_maps
    COMMAND $<TARGET_FILE:Persistence_representations_example_heat_maps>)
install(TARGETS Persistence_representations_example_heat_maps DESTINATION bin)

add_executable ( Sliced_Wasserstein sliced_wasserstein.cpp )
add_test(NAME Sliced_Wasserstein
    COMMAND $<TARGET_FILE:Sliced_Wasserstein>)
install(TARGETS Sliced_Wasserstein DESTINATION bin)

=== debian/changelog ===
gudhi (3.1.1+dfsg-1build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:33:14 +0100

gudhi (3.1.1+dfsg-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Gard Spreemann <gspr@nonempty.org>  Fri, 07 Feb 2020 18:04:44 +0100

gudhi (3.1.0+dfsg-2) unstable; urgency=medium

  * Require PyTest for autopkgtests.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 22 Jan 2020 11:16:38 +0100

gudhi (3.1.0+dfsg-1) unstable; urgency=medium

  * Allow forcing parallel builds for local use.
  * Standards-version 4.5.0.0. No changes needed.
  * New upstream release.

 -- Gard Spreemann <gspr@nonempty.org>  Tue, 21 Jan 2020 10:26:33 +0100

gudhi (3.0.0+dfsg-4) unstable; urgency=medium

  * Drop 0003-Don-t-set-runtime-library-dirs-for-Python-extensions.patch
    in favor of CMake option.
  * Disable parallel builds. A lot of buildds seem to be swapping out, and
    some Ubuntu ones run out of memory outright. (Closes: #945226)
  * Standards-version 4.4.1. No changes needed.
  * Drop 0004-Force-linking-of-Python-module-with-CGAL.patch since CGAL is
    now header-only.
  * Add 0007-Move-towards-reproducible-builds.patch to move towards
    reproducible builds.

 -- Gard Spreemann <gspr@nonempty.org>  Tue, 10 Dec 2019 14:33:51 +0100

gudhi (3.0.0+dfsg-3) unstable; urgency=medium

  * Disable build-time tests on i386 and s390x.
  * Drop support for mipsel due to failure to build because of too little
    addressable memory. This introduces an explicit architecture list for
    the packages.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 30 Oct 2019 09:27:19 +0100

gudhi (3.0.0+dfsg-2) unstable; urgency=medium

  * Fix binary-arch build.
  * Disable parallel building also on i386.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 23 Oct 2019 22:18:22 +0200

gudhi (3.0.0+dfsg-1) unstable; urgency=medium

  * New upstream:
    - Python interface for sparse Rips complexes.
    - New C++ interface for alpha complexes.
  * Standards-version 4.4.0. No changes needed.
  * DH compat 12.
  * Declare Rules-Requires-Root: no.
  * Change maintainer email address.
  * Refresh patches for new version.
    - Drop 0008-Propagate-CXXFLAGS-when-building-Python-modules.patch, seems no
      longer needed.
    - Add 0008-Install-Python-module-in-correct-location.patch to install Python
      modules in correct location.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 23 Oct 2019 11:47:25 +0200

=== debian/control ===
Source: gudhi
Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.5.0.0
Build-Depends: cmake (>= 3.1),
               cython3,
               debhelper (>= 12),
               dh-python,
               libboost-chrono-dev (>= 1.56),
               libboost-filesystem-dev (>= 1.56),
               libboost-program-options-dev (>= 1.56),
               libboost-system-dev (>= 1.56),
               libboost-test-dev (>= 1.56),
               libboost-timer-dev (>= 1.56),
               libcgal-dev (>= 5.0),
               libcgal-qt5-dev (>> 4.11.0),
               libeigen3-dev,
               libgmp-dev,
               libqglviewer-dev-qt5,
               libtbb-dev,
               python3-all-dev,
               python3-matplotlib,
               python3-pytest,
               python3-setuptools,
               python3-tk,
               qtbase5-dev
Build-Depends-Indep: doxygen,
                     graphviz
Rules-Requires-Root: no
Homepage: http://gudhi.gforge.inria.fr/
Vcs-Browser: https://git.nonempty.org/debian-gudhi
Vcs-Git: https://git.nonempty.org/debian-gudhi -b debian/sid

Package: libgudhi-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: libboost-chrono-dev (>= 1.56),
         libboost-filesystem-dev (>= 1.56),
         libboost-program-options-dev (>= 1.56),
         libboost-system-dev (>= 1.56),
         libboost-test-dev (>= 1.56),
         libboost-timer-dev (>= 1.56),
         libcgal-dev (>= 5.0),
         libeigen3-dev (>= 3.1.0),
         libgmp-dev (>= 4.2),
         libtbb-dev,
         ${misc:Depends}
Suggests: libgudhi-doc, libgudhi-examples
Description: Generic open source C++ library for topological data analysis
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains the header files. See the libgudhi-examples
 package for example programs using the library.

Package: libgudhi-examples
Section: misc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libgudhi-dev, libgudhi-doc
Description: Example programs for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains some source code examples.

Package: libgudhi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-mathjax, ${misc:Depends}
Description: Documentation for the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains documentation.

Package: python3-gudhi
Section: python
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: python3-matplotlib,
         python3-tk,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python 3 interface to the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains GUDHI's Python (3) interface.

Package: gudhui
Section: math
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: GUI for some of the functionality of the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains GudhUI, a graphical interface to a few of GUDHI's
 features. Be aware that it is quite rough around the edges.

Package: gudhi-utils
Section: math
Architecture: amd64 arm64 i386 mips64el ppc64el s390x ia64 ppc64 riscv64 sparc64 x32
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Utilities from the GUDHI library
 The GUDHI library is a generic open source C++ library for
 Topological Data Analysis (TDA) and Higher Dimensional Geometry
 Understanding. The library offers state-of-the-art data structures
 and algorithms to construct simplicial complexes and compute
 persistent homology.
 .
 The GUDHI library is developed as part of the GUDHI project supported
 by the European Research Council.
 .
 This package contains some utilities built with the GUDHI library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

TMPBIN:=debian/tmp/usr/bin

PY3VERS:=$(shell py3versions -vs)
DEFAULT_PY3VER=$(shell py3versions -vd)
REMAINING_PY3VERS:=$(filter-out $(DEFAULT_PY3VER), $(PY3VERS))

DHFLAGS+=--buildsystem=cmake

# To fix #945226, we turn off parallel builds everywhere, except if
# someone explicitly wants them enabled by setting the environment
# variable ALLOW_PARALLEL.
ifeq (, $(ALLOW_PARALLEL))
	DHFLAGS+=--no-parallel
endif

# The buildds run out of memory on some architectures. On those, we
# force non-parallel building.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),i386 mips mipsel m68k powerpcspe x32))
	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=5
# We have disabled parallel builds in general now. Consider disabling
# for certain architectures if it's reenabled globally.
#	DHFLAGS+=--no-parallel
endif

# Disable tests on i386 due to rounding problem in some. See upstream GitHub issue #118.
# Disable tests on s390x, as a few are broken. See #943384.
ifneq (, $(filter $(shell dpkg-architecture --query DEB_BUILD_ARCH),i386 s390x x32))
	export DEB_BUILD_MAINT_OPTIONS := $(DEB_BUILD_MAINT_OPTIONS) nocheck
endif

%:
# The --buildirectory=build is there so that we can easily get a hold
# of documentation and examples, which are not installed by upstream.
	dh $@ $(DHFLAGS) --with=python3 --builddirectory=build
	for py3ver in $(REMAINING_PY3VERS) ; do \
		dh $@ $(DHFLAGS) --with=python3 --builddirectory=build$$py3ver ; \
	done

override_dh_auto_configure:
	dh_auto_configure $(DHFLAGS) -- -DWITH_GUDHI_BENCHMARK=true -DWITH_GUDHI_EXAMPLE=true -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=true -DPython_ADDITIONAL_VERSIONS=$(DEFAULT_PY3VER) -DUSER_VERSION_DIR=gudhi -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false
	for py3ver in $(REMAINING_PY3VERS) ; do \
		dh_auto_configure $(DHFLAGS) --builddirectory=build$$py3ver -- -DWITH_GUDHI_BENCHMARK=false -DWITH_GUDHI_EXAMPLE=false -DWITH_GUDHI_PYTHON=true -DWITH_GUDHI_TEST=true -DWITH_GUDHI_UTILITIES=false -DPython_ADDITIONAL_VERSIONS=$$py3ver -DWITH_GUDHI_PYTHON_RUNTIME_LIBRARY_DIRS=false ; \
	done

override_dh_auto_build-arch:
	dh_auto_build $(DHFLAGS) --builddirectory=build
	for py3ver in $(REMAINING_PY3VERS) ; do \
		dh_auto_build $(DHFLAGS) --builddirectory=build$$py3ver ; \
	done

override_dh_auto_build-indep:
	make -C build doxygen
	dh_auto_build $(DHFLAGS) --builddirectory=build

override_dh_auto_test-indep:

override_dh_auto_test-arch:
# I believe this should be handled automatically by dh_auto_test,
# but see #901678.
ifeq (, $(filter nocheck,$(DEB_BUILD_MAINT_OPTIONS)))
	dh_auto_test $(DHFLAGS) --no-parallel --builddirectory=build
	for py3ver in $(REMAINING_PY3VERS) ; do \
		dh_auto_test $(DHFLAGS) --no-parallel --builddirectory=build$$py3ver ; \
	done
else
	@echo "Skipping tests due to nocheck flag."
endif

override_dh_auto_install:
	find src -type f -path '*/example/*' \( -name '*.cpp' -o \( -name '*.txt' -a ! -iname 'cmake*' \) \) -exec sh -c 'name=$$(echo $$0 | sed s/src\\/// | sed s/example\\///); install -D -m 644 $$0 debian/tmp/usr/share/doc/libgudhi-examples/$$name' {} \;

	dh_auto_install $(DHFLAGS) --builddirectory=build
	for py3ver in $(REMAINING_PY3VERS) ; do \
		dh_auto_install $(DHFLAGS) --builddirectory=build$$py3ver ; \
	done

	# Remove installed information about Miniball header.
	rm -f build/gudhi/include/gudhi/Miniball.COPYRIGHT
	rm -f build/gudhi/include/gudhi/Miniball.README

	mv $(TMPBIN)/Nerve \
	   $(TMPBIN)/gudhi-nerve
	mv $(TMPBIN)/VoronoiGIC \
	   $(TMPBIN)/gudhi-voronoi-gic
	mv $(TMPBIN)/Witness_complex_strong_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-strong-witness-persistence
	mv $(TMPBIN)/Witness_complex_weak_witness_persistence \
	   $(TMPBIN)/gudhi-witness-complex-weak-witness-persistence
	mv $(TMPBIN)/alpha_complex_3d_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-3d-persistence
	mv $(TMPBIN)/alpha_complex_persistence \
	   $(TMPBIN)/gudhi-alpha-complex-persistence
	mv $(TMPBIN)/bottleneck_distance \
	   $(TMPBIN)/gudhi-bottleneck-distance
	mv $(TMPBIN)/cech_persistence \
	   $(TMPBIN)/gudhi-cech-persistence
	mv $(TMPBIN)/cubical_complex_persistence \
	   $(TMPBIN)/gudhi-cubical-complex-persistence
	mv $(TMPBIN)/off_file_from_shape_generator \
	   $(TMPBIN)/gudhi-off-file-from-shape-generator
	mv $(TMPBIN)/periodic_cubical_complex_persistence \
	   $(TMPBIN)/gudhi-periodic-cubical-complex-persistence
	mv $(TMPBIN)/rips_correlation_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-correlation-matrix-persistence
	mv $(TMPBIN)/rips_distance_matrix_persistence \
	   $(TMPBIN)/gudhi-rips-distance-matrix-persistence
	mv $(TMPBIN)/rips_persistence \
	   $(TMPBIN)/gudhi-rips-persistence
	mv $(TMPBIN)/sparse_rips_persistence \
	   $(TMPBIN)/gudhi-sparse-rips-persistence

	mv $(TMPBIN)/GudhUI $(TMPBIN)/gudhui

override_dh_compress:
	dh_compress -X.cpp

override_dh_install:
	dh_install -X__pycache__ -X.pyc -X.pyo

=== debian/tests/control ===
Tests: python-upstream.sh
Depends: python3-all, python3-gudhi, python3-pytest, python3-scipy

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/gudhi-release-?(\d\S+)\.tar\.gz/gudhi-$1\.tar\.gz/,\
  dversionmangle=s/\+dfsg(\.\d+)?$//,\
  uversionmangle=s/.?(RC|rc)/~rc/ \
  https://github.com/GUDHI/gudhi-devel/releases .*/archive/tags/gudhi-release-(\d\S+)\.tar\.gz
